package com.jah0wl.catan.utils;

/*! on pos:
  verticies:

		//   4__5
		//  3/  \0   no girado            (clockwise?)
		//   \__/
		//   2  1

  edges

        //      4
		//     __
		//   3/  \5
		//  2 \__/0
		//     1

// any edge is adjacent to verticies of pos and pos+1%6 of the same hexagon

*/
public class Coordinate {
	public int c;
	public int r;
	public int pos;
	
	public Coordinate(Coordinate c){
		this(c.c,c.r,c.pos);
	}
	public Coordinate(int c, int r, int pos){
		setCoordinates(c,r,pos);
	}

	public void setCoordenadas(Coordinate c){
		setCoordinates(c.c,c.r,c.pos);
	}
	public void setCoordinates(int c, int r, int pos){
		this.c=c;
		this.r=r;
		this.pos=pos;
	}
	
	public boolean equals(Object o){
        if(! (o instanceof Coordinate) ) return false;//!my
        Coordinate co = (Coordinate) o;
		return c==co.c && r==co.r && pos==co.pos;
	}
	
	public int hashCode(){
		return c*12+r*61+pos*17;
	}
							   
	// Otras operaciones
	// Other operations

/*! on pos:
  edges
        //      4
		//     __
		//   3/  \5
		//  2 \__/0
		//     1
  verticies:
		//   4__5
		//  3/  \0   no girado            (clockwise?)
		//   \__/
		//   2  1

*/

    public void translVertice(){                      //todo very strange method
		if (c%2==0){
			// c par
			// c is even
			switch (pos){
			case 3:
				setCoordinates(c-1, r, 1);
				break;				
			case 4:
				setCoordinates(c, r-1, 2);
				break;				
			case 5:
				setCoordinates(c, r-1, 1);
				break;				
			}
		}else{
			// c impar
			// c is odd
			switch (pos){
			case 0:
				setCoordinates(c+1, r-1, 2);
				break;				
			case 2:
				setCoordinates(c-1, r, 0);
				break;				
			case 3:
				setCoordinates(c-1, r-1, 1);
				break;				
			case 4:
				setCoordinates(c-1, r-1, 0);
				break;				
			case 5:
				setCoordinates(c, r-1, 1);
				break;				
			}
		}	
		setCoordinates(c,r,pos);
	}


        //      4          no reaction for 0, if c is even works only for 3,4
		//     __
		//   3/  \5    c even: same row
		//  2 \__/0	   c even: next row
		//     1
//	public void translArista (){
	public void translEdge (){
		if (c%2==0){
			// c par
			switch (pos){
			case 3:
				setCoordinates(c-1, r, 0);
				break;
			case 4:
				setCoordinates(c, r-1, 1);
				break;				
			}
		}else{
			// c impar
			switch (pos){
			case 2:
				setCoordinates(c-1, r, 5);
				break;				
			case 3:
				setCoordinates(c-1, r-1, 0);
				break;				
			case 4:
				setCoordinates(c, r-1, 1);
				break;				
			case 5:
				setCoordinates(c+1, r-1, 2);
				break;				
			}
		}	
		setCoordinates(c,r,pos);
	}	
	                                             //returns
	// Devuelve las coordenadas del hexagono que se encuentra  //that meets   touch
	// tocando en la posicion actual
	// En "pos" devuelve la arista comun

    // auto translate:
    // Gives back the coordinates of the hexagon that is
    // touching in the present position
    // In pos gives back the common edge

    // I think it returns coordinates of the field adjacent over the edge
    // and also corresponding edge of that field
        //edges

        //      4
		//     __
		//   3/  \5    c even: same row
		//  2 \__/0	   c even: next row
		//     1
    public Coordinate getAdjacentFieldEdge(){
		switch (pos){				
		case 1:
			return new Coordinate(c, r+1, 4);
		case 4:
			return new Coordinate(c, r-1, 1);
		}		
		if (c%2==0){
			// c par       // even
			switch (pos){
			case 0:
				return new Coordinate(c+1, r+1, 3);
			case 2:
				return new Coordinate(c-1, r+1, 5);
			case 3:
				return new Coordinate(c-1, r, 0);
			case 5:
				return new Coordinate(c+1, r, 2);
			}
		}else{
			// c impar      // odd
			switch (pos){
			case 0:
				return new Coordinate(c+1, r, 3);
			case 2:
				return new Coordinate(c-1, r, 5);
			case 3:
				return new Coordinate(c-1, r-1, 0);
			case 5:
				return new Coordinate(c+1, r-1, 2);
			}
		}	
		// never gets here
		// nunca se llegara aqui
		return null;
	}
}