package com.jah0wl.catan.utils;

import javax.microedition.lcdui.Graphics;
import com.jah0wl.utils.*;

public class Dice {        //dado
	
//	private final static int[] VALUE_MASKS = {0,8,20,28,85,93,119};
    //                                          1   2    3        4            5           6
    private final static int[] VALUE_MASKS = {0,8,16+4,16+8+4,1 + 4 + 64 + 16,64+16+8+4+1,64+32+16+4+2+1};
	private final static int[] POINT_MASKS = {0,1,2,4,8,16,32,64};
	
	private Point location;
	private int[] value = new int[2];
		
	// Constructor
	public Dice(Point p){
		this(p.x,p.y);
	}
	public Dice(int x, int y){
		location = new Point(x,y);
		value[0] = 0;
		value[1] = 0;
	}
	
	// Observadoras selectoras
	public Point getLocation(){
		return location.getLocation();
	}
	
	public int getValue(){
		return value[0]+value[1];
	}
	
	public void setLocation(Point p){
		setLocation(p.x,p.y);
	}
	public void setLocation(int x, int y){
		location.setLocation(x,y);
	}
		
	public void changeValue(){
		value[0]=Random.random(6);
		value[1]=Random.random(6);
	}
	
	// Otras operaciones
	// Other operations
	public void paintOne(Graphics g, int x, int y, int value){
		Point[] POINT_COORS = 
		{null, new Point(x+2,y+2), new Point(x+2,y+4), new Point(x+2,y+6),
		 new Point(x+4,y+4),
		 new Point(x+6,y+2), new Point(x+6,y+4), new Point(x+6,y+6)};
        //translate.google.com is great!!!
        //we drew the white bottom. we drew the frame of the dice. we drew the points
		// dibujamos el fondo blanco
		g.setColor(255,255,255);
		g.fillRect(x+1,y+1,7,7);
		
		// dibujamos el marco del dado
		g.setColor(0,0,0);
		g.drawRect(x,y,8,8);
		
		// dibujamos los puntos      //puntos == score  / point
		for (int i=1;i<=7;i++)
			if ((VALUE_MASKS[value] & POINT_MASKS[i]) == POINT_MASKS[i])
				g.drawLine(POINT_COORS[i].x,POINT_COORS[i].y,
						   POINT_COORS[i].x,POINT_COORS[i].y);
	}
	
	public void paint(Graphics g){
		int x=getLocation().x;		
		int y=getLocation().y;	
		paintOne(g,x,y,value[0]);
		paintOne(g,x+10,y,value[1]);
	}
		
}