package com.jah0wl.utils;

public class Hexagon{
	
	public int x;
	public int y;
	public int radio;
	
	private int[] xpoints = new int[6];
	private int[] ypoints = new int[6];	
	
	// Constructor
	public Hexagon(){
		this(0,0,0);	
	}
	public Hexagon(int r){
		this(0,0,r);	
	}	
	public Hexagon(Point p, int r){
		this(p.x,p.y,r);
	}
	public Hexagon(int x, int y, int r){
		this.x=x;
		this.y=y;
		this.radio=r;
		recalculate();
	}

	// Observadoras selectoras
	public Point getLocation(){
		return new Point(x,y);
	}
	
	public void setLocation(Point p){
		this.setLocation(p.x,p.y);
	}
	public void setLocation(int x, int y){
		this.x=x;
		this.y=y;
		recalculate();
	}
		
	// Otras operaciones                      // other operations
	private void recalculate(){  // reposiciona();
		//
		//   4__5
		//  3/  \0   no girado     //nondrawee
		//   \__/					
		//   2  1
		//
		//  varX = sin30
		//  varY = cos30
		//  
		//	0: (x+r, y)
		//	1: (x+r*varX, y+r*varY)
		//	2: (x-r*varX, y+r*varY)
		//	3: (x-r, y)
		//	4: (x-r*varX, y-r*varY)
		//	5: (x+r*varX, y-r*varY)
		//
		
		Float sin30 = new Float(Float.sin(Float.PI.Div(6)));
		Float cos30 = new Float(Float.cos(Float.PI.Div(6)));
				
		xpoints[0]=x+radio;
		ypoints[0]=y;
		xpoints[1]=x+(int) sin30.Mul(radio).toLong();
		ypoints[1]=y+(int) cos30.Mul(radio).toLong();
		xpoints[2]=x-(int) sin30.Mul(radio).toLong();
		ypoints[2]=y+(int) cos30.Mul(radio).toLong();
		xpoints[3]=x-radio;
		ypoints[3]=y;
		xpoints[4]=x-(int) sin30.Mul(radio).toLong();
		ypoints[4]=y-(int) cos30.Mul(radio).toLong();
		xpoints[5]=x+(int) sin30.Mul(radio).toLong();
		ypoints[5]=y-(int) cos30.Mul(radio).toLong();		
	}
	
	public Point getPoint(int pos){
		return new Point(xpoints[pos],ypoints[pos]);
	}
	
	public Rectangle getBounds(){
		int height = 2 * (int) Float.cos(Float.PI.Div(6)).Mul(radio).toLong();
		return new Rectangle(this.getPoint(3).x,this.getPoint(4).y,
							 radio*2,height);
	}	
	
	public void Move(int x,int y){
		this.x+=x;
		this.y+=y;
		recalculate();
	}
}	